#!/usr/bin/tclsh

source ~andi/bin/fileformat.tcl

foreach datafile $argv {

	set datafilefp [open $datafile r]
	set newdatafilefp [open "$datafile.new" w]

	set columns 0
	set line 0
	
	while {![eof $datafilefp]} {
		set newdataline ""
		incr line
		gets $datafilefp dataline
		
		if {$dataline != ""} {
			if {$columns==0} {
				set columns [llength $dataline]
				puts "$columns columns"
				set dbmax1col [get_column $columns "dbmax1"]
				set dbmin1col [get_column $columns "dbmin1"]
				set dbmax2col [get_column $columns "dbmax2"]
				set dbmin2col [get_column $columns "dbmin2"]
			} else {
				if {$columns!=[llength $dataline]} {
					puts "WARNING: [llength $dataline] and not $columns columns in line $line"
				}
			}

			for {set i 1} {$i <= $columns} {incr i} {
				if {$dbmax1col==$i || $dbmin1col==$i || $dbmax2col==$i || $dbmin2col==$i} {
					set oldval [lindex $dataline [expr $i-1]]
					if {$oldval=="?" || $oldval==""} {
						lappend newdataline "?"
					} else {
						if {$oldval>0} {
							lappend newdataline [expr log($oldval)/log(10)*20]
						} else {
							puts "WARNING: value for amplitude is negative"
							lappend newdataline $oldval
						}
					}
				} else {
					lappend newdataline [lindex $dataline [expr $i-1]]
				}
			}
			puts $newdatafilefp $newdataline
		}
	}

	close $datafilefp
	close $newdatafilefp
}
