#!/usr/bin/python

import fileinput, string, os, sys;

filename=sys.argv[1]

sections = 1

sectionready=0
for line in fileinput.input(filename):
	if len(string.strip(line))==0:
		sectionready = 1
	else:
		if sectionready==1:
			sections += 1
			sectionready=0
		else:
			sectionready=0
fileinput.close()

print "file has "+str(sections)+" sections"
datafile=open("gnuplot.dat","w")
gnuplot=os.popen("gnuplot","w")
gnuplot.write("set term post color solid\n")
gnuplot.write("set encoding iso\n")
gnuplot.write("set output \"gnuplot.ps\"\n")
gnuplot.write("set zeroaxis\n")
gnuplot.write("set data style lines\n")
gnuplot.write("set xlabel \"xval [arb. u.]\"\n")
gnuplot.write("set ylabel \"yval [arb. u.]\"\n")
gnuplot.write("plot \""+filename+"\" u ($3*cos($4/180*pi)):($3*sin($4/180*pi)) not\n")
gnuplot.write("set xlabel \"base voltage [V]\"\n")
gnuplot.write("set ylabel \"amplitude [arb. u.]\"\n")
for section in range(0,sections):
	gnuplot2=os.popen("gnuplot >/dev/null 2>gnuplot.out","w")
	gnuplot2.write("f(x)=m*x+t\n")
	gnuplot2.write("g(x)=c\n")
	gnuplot2.write("h(x)=mh*x+th\n")
	gnuplot2.write("fit f(x) \""+filename+"\" every :::"+str(section)+"::"+str(section)+" u ($3*cos($4/180*pi)):($3*sin($4/180*pi)) via m,t\n")
	gnuplot2.write("fit g(x) \""+filename+"\" every :::"+str(section)+"::"+str(section)+" u 0:1 via c\n")
	gnuplot2.write("fit h(x) \""+filename+"\" every :::"+str(section)+"::"+str(section)+" u ($2/1000):($3*sin($4/180*pi+atan(1/m))) via mh,th\n")
	gnuplot2.write("print m,t,c,mh,th")
	gnuplot2.close();

	test=open("gnuplot.out","r")
	while 1:
		line=test.readline()
		if not line: break
		oldline=line
	test.close()

	linearray=string.split(oldline)
	m=linearray[0]
	t=linearray[1]
	f=linearray[2]
	m2=linearray[3]
	t2=linearray[4]
	print f,m,t
	datafile.write(f+" "+m+" "+t+" "+m2+" "+t2+"\n")

	if section==0:
		gnuplot.write("plot ")
	else:
		gnuplot.write(", \\\n")

	gnuplot.write("\""+filename+"\" every :::"+str(section)+"::"+str(section)+" u ($2/1000):($3*sin($4/180*pi+atan(1/("+m+")))) not")
datafile.close()
gnuplot.write("\n")
gnuplot.write("set ytics nomirror\n")
gnuplot.write("set y2tics\n")
gnuplot.write("set xlabel \"frequency [Hz]\"\n")
gnuplot.write("set ylabel \"zero-point [V]\"\n")
gnuplot.write("set y2label \"angle of amplitude line []\"\n")
gnuplot.write("plot \"gnuplot.dat\" u 1:(-$5/$4) ti \"zero points\", \"\" u 1:(atan($4)/pi*180) axes x1y2 ti \"angle (av)\",\"\" u 1:(atan($2)/pi*180) axes x1y2 ti \"angle (xy)\"\n")
gnuplot.close()

