#!/usr/bin/tclsh

#
# which number of columns are valid:
#
set columnlist "10 11 12 13 17 18 20 22 23 24 27 31 40 41 42 43 44 45 46"

#
# a description of the content of the different data file formats
#
set columntype(10) "date time bathtemp celltemp pressure uhold dbmax1 frqmax1 dbmax2 frqmax2"
set columntype(11) "date time bathtemp celltemp pressure baratron uhold dbmax1 frqmax1 dbmax2 frqmax2"
set columntype(12) "date time bathtemp celltemp frqmax1 dbmax1 frqmin1 dbmin1 frqmax2 dbmax2 frqmin2 dbmin2"
set columntype(13) "date time bathtemp celltemp frqmax1 dbmax1 frqmin1 dbmin1 frqmax2 dbmax2 frqmin2 dbmin2 uhold"
set columntype(17) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err filused"
set columntype(18) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err filused levelcap"
set columntype(20) "date time bathtemp celltemp pressure baratron uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err subsres"
set columntype(22) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err"
set columntype(23) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err filused"
set columntype(24) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err filused levelcap"
set columntype(27) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err filused levelcap pulseamp pulselength pulsenumber"
set columntype(31) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err filused levelcap pulseamp pulselength pulsenumber napower nawid1 nawid1 napoints"
set columntype(40) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err off1 off1_err lin1 lin1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err off2 off2_err lin2 lin2_err filused pulseamp pulselength pulsenumber napower nawid1 nawid2 napoints coil_current coil_voltage"
set columntype(41) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err off1 off1_err lin1 lin1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err off2 off2_err lin2 lin2_err filused levelcap pulseamp pulselength pulsenumber napower nawid1 nawid2 napoints coil_current coil_voltage"
set columntype(42) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err off1 off1_err lin1 lin1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err off2 off2_err lin2 lin2_err filused levelcap pulseamp pulselength pulsenumber napower nawid1 nawid2 napoints coil_resistance coil_current coil_voltage"
set columntype(43) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err off1 off1_err lin1 lin1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err off2 off2_err lin2 lin2_err filused levelcap pulseamp pulselength pulsenumber napower nawid1 nawid2 napoints coil_current coil_voltage fil_voltage fil_current"
set columntype(44) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err off1 off1_err lin1 lin1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err off2 off2_err lin2 lin2_err filused levelcap pulseamp pulselength pulsenumber napower nawid1 nawid2 napoints coil_current coil_voltage level_r level_phi level_amp"
set columntype(45) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err off1 off1_err lin1 lin1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err off2 off2_err lin2 lin2_err filused levelcap pulseamp pulselength pulsenumber napower nawid1 nawid2 napoints coil_current coil_voltage fil_voltage fil_current tracenum dummy"
set columntype(46) "date time bathtemp celltemp pressure baratron fil1res fil2res subsres uhold amp1 amp1_err frq1 frq1_err wid1 wid1_err off1 off1_err lin1 lin1_err amp2 amp2_err frq2 frq2_err wid2 wid2_err off2 off2_err lin2 lin2_err filused levelcap pulseamp pulselength pulsenumber napower1 napower2 nawid1 nawid2 napoints coil_current coil_voltage fil_voltage fil_current tracenum dummy"

#
# a description of the used column-data follows:
#
set columndesc(date) "date of measurement"
set columndesc(time) "time of measurement"
set columndesc(bathtemp) "temperature of helium bath"
set columndesc(celltemp) "temperature of cavity"
set columndesc(pressure) "pressure in panel"
set columndesc(baratron) "pressure in panel (baratron)"
set columndesc(uhold) "holding voltage applied to substrate"
set columndesc(dbmax1) "amplitude of maximum 1 (in dB)"
set columndesc(frqmax1) "frequency of maximum 1"
set columndesc(dbmin1) "amplitude of minimum 1 (in dB)"
set columndesc(frqmin1) "frequency of minimum 1"
set columndesc(dbmax2) "amplitude of maximum 2 (in dB)"
set columndesc(frqmax2) "frequency of maximum 2"
set columndesc(dbmin2) "amplitude of minimum 2 (in dB)"
set columndesc(frqmin2) "frequency of minimum 2"
set columndesc(fil1res) "resistance of filament 1"
set columndesc(fil2res) "resistance of filament 2"
set columndesc(subsres) "resistance of substrate"
set columndesc(amp1) "amplitude of resonance 1"
set columndesc(amp1_err) "error of amplitude of resonance 1 (from least square fit)"
set columndesc(frq1) "frequency of resonance 1"
set columndesc(frq1_err) "error of frequency of resonance 1 (from least square fit)"
set columndesc(wid1) "linewidth of resonance 1"
set columndesc(wid1_err) "error of linewidth of resonance 1 (from least square fit)"
set columndesc(off1) "constant offset of resonance 1"
set columndesc(off1_err) "error of constant offset of resonance 1 (from least square fit)"
set columndesc(lin1) "linear offset of resonance 1"
set columndesc(lin1_err) "error of linear offset of resonance 1 (from least square fit)"
set columndesc(amp2) "amplitude of resonance 2"
set columndesc(amp2_err) "error of amplitude of resonance 2 (from least square fit)"
set columndesc(frq2) "frequency of resonance 2"
set columndesc(frq2_err) "error of frequency of resonance 2 (from least square fit)"
set columndesc(wid2) "linewidth of resonance 2"
set columndesc(wid2_err) "error of linewidth of resonance 2 (from least square fit)"
set columndesc(off2) "constant offset of resonance 2"
set columndesc(off2_err) "error of constant offset of resonance 2 (from least square fit)"
set columndesc(lin2) "linear offset of resonance 2"
set columndesc(lin2_err) "error of linear offset of resonance 2 (from least square fit)"
set columndesc(filused) "number of filament wich was used for pulsing"
set columndesc(levelcap) "capacitance of the level capacitor"
set columndesc(pulseamp) "amplitude of the filament-pulse"
set columndesc(pulselength) "duration of the filament-pulse"
set columndesc(pulsenumber) "number of filament-pulses per single measurement"
set columndesc(napower) "measurement power of network analyzer (in dBm)"
set columndesc(napower1) "measurement power of network analyzer (in dBm)"
set columndesc(napower2) "measurement power of network analyzer (in dBm)"
set columndesc(nawid1) "frequency width of network analyzer detection (resonance 1)"
set columndesc(nawid2) "frequency width of network analyzer detection (resonance 2)"
set columndesc(napoints) "number of points of network analyzer detection"
set columndesc(coil_resistance) "resistance of magnet coil"
set columndesc(coil_current) "current through magnet coil"
set columndesc(coil_voltage) "voltage drop over magnet coil"
set columndesc(level_r) "level lockin amplitude"
set columndesc(level_phi) "level lockin phase"
set columndesc(level_amp) "level lockin drive-amplitude"
set columndesc(fil_voltage) "voltage drop on filament"
set columndesc(fil_current) "current through filament"
set columndesc(tracenum) "actual number of recorded nwa trace"
set columndesc(dummy) "filler variable"

set usedcolumntypes ""

# search through the list of possible datatypes
foreach columns $columnlist {
	if {[info exists columntype($columns)]} {

		# scan all the used columntypes and collect them in $usedcolumntypes
		foreach coltype $columntype($columns) {
			if {[lsearch $usedcolumntypes $coltype]==-1} {
				lappend usedcolumntypes $coltype
			}
		}
	} else {
		puts "WARNING: datafile-description for `$columns` columns does not exist"
	}
}

# scan all used columntypes ($usedcolumntypes) if there is a description
foreach coltype $usedcolumntypes {
	if {![info exists columndesc($coltype)]} {
		puts "WARNING: columntype-description for `$coltype` does not exist"
	}
}

proc get_column {{columns ""} {coltype ""}} {
	global columnlist columntype;

	if {[lsearch $columnlist $columns]!=-1} {

		set searchresult [lsearch $columntype($columns) $coltype]
		if {$searchresult!=-1} {
			return [expr $searchresult+1]
		} else {
#			puts "WARNING: column type `$coltype` was not found in datafile-description for $columns columns"
			return 0
		}
	} else {
		puts "WARNING: fileformat with `$columns` columns is not defined"
		return 0
	}	
}
